/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.11 Revision 1.157
1# Copyright 2007-2008 Gentoo Foundation 1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.11 2008/05/15 19:49:32 ingmar Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.157 2015/07/01 11:28:23 mrueg Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.0 ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 monolithic ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: This eclass uses the SLOT dependencies from EAPI="1" or compatible, 13# NOTE: KDE 4 ebuilds currently support EAPI 5. This will be
14# hence you must define EAPI="1" in the ebuild, before inheriting any eclasses. 14# reviewed over time as new EAPI versions are approved.
15 15
16inherit base eutils multilib cmake-utils kde4-functions 16if [[ -z ${_KDE4_BASE_ECLASS} ]]; then
17_KDE4_BASE_ECLASS=1
17 18
18EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_postinst pkg_postrm 19# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
20# @DESCRIPTION:
21# If set to "none", do nothing.
22# For any other value, add selinux to IUSE, and depending on that useflag
23# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
24: ${KDE_SELINUX_MODULE:=none}
19 25
20kde4-base_set_qt_dependencies() { 26# @ECLASS-VARIABLE: VIRTUALDBUS_TEST
21 local qt qtcore qtgui qt3support qtdepend qtopengldepend 27# @DESCRIPTION:
28# If defined, launch and use a private dbus session during src_test.
22 29
23 # use dependencies 30# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
24 case "${EAPI}" in 31# @DESCRIPTION:
25 kdebuild-1) 32# For proper description see virtualx.eclass manpage.
26 qt="[accessibility][dbus][gif][jpeg][png][qt3support][ssl][zlib]" 33# Here we redefine default value to be manual, if your package needs virtualx
27 qtcore="[qt3support][ssl]" 34# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
28 qtgui="[accessibility][dbus]" 35: ${VIRTUALX_REQUIRED:=manual}
29 qt3support="[accessibility]" 36
30 case "${OPENGL_REQUIRED}" in 37inherit kde4-functions toolchain-funcs fdo-mime flag-o-matic gnome2-utils virtualx versionator eutils multilib
31 always) 38
32 qt="${qt}[opengl]" 39if [[ ${KDE_BUILD_TYPE} = live ]]; then
33 ;; 40 case ${KDE_SCM} in
34 optional) 41 svn) inherit subversion ;;
35 qt="${qt}[opengl?]" 42 git) inherit git-r3 ;;
36 ;;
37 esac
38 ;;
39 esac 43 esac
44fi
40 45
41 # split qt 46# @ECLASS-VARIABLE: CMAKE_REQUIRED
42 qtdepend=" 47# @DESCRIPTION:
43 x11-libs/qt-core:4${qtcore} 48# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
44 x11-libs/qt-gui:4${qtgui} 49# Please note that if it's set to 'never' you need to explicitly override following phases:
45 x11-libs/qt-qt3support:4${qt3support} 50# src_configure, src_compile, src_test and src_install.
46 x11-libs/qt-script:4 51# Defaults to 'always'.
47 x11-libs/qt-svg:4 52: ${CMAKE_REQUIRED:=always}
48 x11-libs/qt-test:4" 53if [[ ${CMAKE_REQUIRED} = always ]]; then
49 qtopengldepend="x11-libs/qt-opengl:4" 54 buildsystem_eclass="cmake-utils"
55 export_fns="src_configure src_compile src_test src_install"
56fi
50 57
51 # allow monolithic qt for PV < 4.1 58# @ECLASS-VARIABLE: KDE_MINIMAL
59# @DESCRIPTION:
60# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
61# version for apps to work. Currently defaults to 4.4
62# One may override this variable to raise version requirements.
63# Note that it is fixed to ${PV} for kde-base packages.
64KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
65
66# Set slot for KDEBASE known packages
67case ${KDEBASE} in
68 kde-base)
69 SLOT=4/$(get_version_component_range 1-2)
70 KDE_MINIMAL="${PV}"
71 ;;
72 kdevelop)
73 if [[ ${KDE_BUILD_TYPE} = live ]]; then
74 # @ECLASS-VARIABLE: KDEVELOP_VERSION
75 # @DESCRIPTION:
76 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
77 # Applies to KDEBASE=kdevelop only.
78 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.9999}"
79 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
80 # @DESCRIPTION:
81 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
82 # Applies to KDEBASE=kdevelop only.
83 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-4.9999}"
84 else
52 case "${PV}" in 85 case ${PN} in
53 scm|9999.4|4.1*) : ;; 86 kdevelop)
87 KDEVELOP_VERSION=${PV}
88 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
89 ;;
90 kdevplatform|kdevelop-php*|kdevelop-python)
91 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
92 KDEVPLATFORM_VERSION=${PV}
93 ;;
54 *) 94 *)
55 qtdepend="|| ( ( ${qtdepend} ) >=x11-libs/qt-4.3.3:4${qt} )" 95 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
56 qtopengldepend="|| ( ${qtopengldepend} >=x11-libs/qt-4.3.3:4 )" 96 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
97 esac
98 fi
99 SLOT="4"
57 ;; 100 ;;
58 esac 101esac
59 102
60 # opengl dependencies 103inherit ${buildsystem_eclass}
61 case "${OPENGL_REQUIRED}" in
62 always)
63 qtdepend="${qtdepend}
64 ${qtopengldepend}"
65 ;;
66 optional)
67 IUSE="${IUSE} opengl"
68 qtdepend="${qtdepend}
69 opengl? ( ${qtopengldepend} )"
70 ;;
71 *)
72 OPENGL_REQUIRED="never"
73 ;;
74 esac
75 104
76 COMMONDEPEND="${COMMONDEPEND} ${qtdepend}" 105EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
77}
78kde4-base_set_qt_dependencies
79 106
80DEPEND="${DEPEND} ${COMMONDEPEND} 107unset buildsystem_eclass
81 >=dev-util/cmake-2.4.7-r1 108unset export_fns
82 dev-util/pkgconfig 109
83 x11-libs/libXt 110# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
84 x11-proto/xf86vidmodeproto" 111# @DESCRIPTION:
85RDEPEND="${RDEPEND} ${COMMONDEPEND}" 112# Is qtdeclarative required? Possible values are 'always', 'optional' and 'never'.
113# This variable must be set before inheriting any eclasses. Defaults to 'never'.
114DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
115
116# @ECLASS-VARIABLE: QTHELP_REQUIRED
117# @DESCRIPTION:
118# Is qthelp required? Possible values are 'always', 'optional' and 'never'.
119# This variable must be set before inheriting any eclasses. Defaults to 'never'.
120QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
86 121
87# @ECLASS-VARIABLE: OPENGL_REQUIRED 122# @ECLASS-VARIABLE: OPENGL_REQUIRED
88# @DESCRIPTION: 123# @DESCRIPTION:
89# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 124# Is qtopengl required? Possible values are 'always', 'optional' and 'never'.
90# This variable must be set before inheriting any eclasses. Defaults to 'never'. 125# This variable must be set before inheriting any eclasses. Defaults to 'never'.
91OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 126OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
127
128# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
129# @DESCRIPTION:
130# Is qtmultimedia required? Possible values are 'always', 'optional' and 'never'.
131# This variable must be set before inheriting any eclasses. Defaults to 'never'.
132MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
92 133
93# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 134# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
94# @DESCRIPTION: 135# @DESCRIPTION:
95# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 136# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
96# This variable must be set before inheriting any eclasses. Defaults to 'never'. 137# This variable must be set before inheriting any eclasses. Defaults to 'never'.
97CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}" 138CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
98 139
99case "${CPPUNIT_REQUIRED}" in 140# @ECLASS-VARIABLE: KDE_REQUIRED
141# @DESCRIPTION:
142# Is kde required? Possible values are 'always', 'optional' and 'never'.
143# This variable must be set before inheriting any eclasses. Defaults to 'always'
144# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
145# Note that for kde-base packages this variable is fixed to 'always'.
146KDE_REQUIRED="${KDE_REQUIRED:-always}"
147
148# @ECLASS-VARIABLE: KDE_HANDBOOK
149# @DESCRIPTION:
150# Set to enable handbook in application. Possible values are 'always', 'optional'
151# (handbook USE flag) and 'never'.
152# This variable must be set before inheriting any eclasses. Defaults to 'never'.
153# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
154# ensures buildtime and runtime dependencies.
155KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
156
157# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
158# @DESCRIPTION:
159# Set this varible if you want your live package to manage its
160# translations. (Mostly all kde ebuilds does not ship documentation
161# and translations in live ebuilds)
162if [[ ${KDE_BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
163 # Kdebase actualy provides the handbooks even for live stuff
164 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
165 KDE_LINGUAS=""
166fi
167
168# Setup packages inheriting this eclass
169case ${KDEBASE} in
170 kde-base)
171 HOMEPAGE="http://www.kde.org/"
172 LICENSE="GPL-2"
173 if [[ ${KDE_BUILD_TYPE} = live && -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
174 # Disable tests for live ebuilds by default
175 RESTRICT+=" test"
176 fi
177
178 # This code is to prevent portage from searching GENTOO_MIRRORS for
179 # packages that will never be mirrored. (As they only will ever be in
180 # the overlay).
181 case ${PV} in
182 *9999* | 4.?.[6-9]? | 4.??.[6-9]? | ??.?.[6-9]? | ??.??.[6-9]?)
183 RESTRICT+=" mirror"
184 ;;
185 esac
186 ;;
187 kdevelop)
188 HOMEPAGE="http://www.kdevelop.org/"
189 LICENSE="GPL-2"
190 ;;
191esac
192
193# @ECLASS-VARIABLE: QT_MINIMAL
194# @DESCRIPTION:
195# Determine version of qt we enforce as minimal for the package.
196QT_MINIMAL="${QT_MINIMAL:-4.8.5}"
197
198# Declarative dependencies
199qtdeclarativedepend="
200 >=dev-qt/qtdeclarative-${QT_MINIMAL}:4
201"
202case ${DECLARATIVE_REQUIRED} in
100 always) 203 always)
101 DEPEND="${DEPEND} dev-util/cppunit" 204 COMMONDEPEND+=" ${qtdeclarativedepend}"
102 ;; 205 ;;
103 optional) 206 optional)
104 IUSE="${IUSE} test" 207 IUSE+=" declarative"
105 DEPEND="${DEPEND} 208 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
106 test? ( dev-util/cppunit )"
107 ;; 209 ;;
210 *) ;;
211esac
212unset qtdeclarativedepend
213
214# QtHelp dependencies
215qthelpdepend="
216 >=dev-qt/qthelp-${QT_MINIMAL}:4
217"
218case ${QTHELP_REQUIRED} in
219 always)
220 COMMONDEPEND+=" ${qthelpdepend}"
221 ;;
222 optional)
223 IUSE+=" qthelp"
224 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
225 ;;
226esac
227unset qthelpdepend
228
229# OpenGL dependencies
230qtopengldepend="
231 >=dev-qt/qtopengl-${QT_MINIMAL}:4
232"
233case ${OPENGL_REQUIRED} in
234 always)
235 COMMONDEPEND+=" ${qtopengldepend}"
236 ;;
237 optional)
238 IUSE+=" opengl"
239 COMMONDEPEND+=" opengl? ( ${qtopengldepend} )"
240 ;;
241 *) ;;
242esac
243unset qtopengldepend
244
245# MultiMedia dependencies
246qtmultimediadepend="
247 >=dev-qt/qtmultimedia-${QT_MINIMAL}:4
248"
249case ${MULTIMEDIA_REQUIRED} in
250 always)
251 COMMONDEPEND+=" ${qtmultimediadepend}"
252 ;;
253 optional)
254 IUSE+=" multimedia"
255 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
256 ;;
257 *) ;;
258esac
259unset qtmultimediadepend
260
261# CppUnit dependencies
262cppuintdepend="
263 dev-util/cppunit
264"
265case ${CPPUNIT_REQUIRED} in
266 always)
267 DEPEND+=" ${cppuintdepend}"
268 ;;
269 optional)
270 IUSE+=" test"
271 DEPEND+=" test? ( ${cppuintdepend} )"
272 ;;
273 *) ;;
274esac
275unset cppuintdepend
276
277# KDE dependencies
278# Qt accessibility classes are needed in various places, bug 325461
279kdecommondepend="
280 dev-lang/perl
281 >=dev-qt/qt3support-${QT_MINIMAL}:4[accessibility]
282 >=dev-qt/qtcore-${QT_MINIMAL}:4[qt3support,ssl]
283 >=dev-qt/qtdbus-${QT_MINIMAL}:4
284 >=dev-qt/designer-${QT_MINIMAL}:4
285 >=dev-qt/qtgui-${QT_MINIMAL}:4[accessibility,dbus(+)]
286 >=dev-qt/qtscript-${QT_MINIMAL}:4
287 >=dev-qt/qtsql-${QT_MINIMAL}:4[qt3support]
288 >=dev-qt/qtsvg-${QT_MINIMAL}:4
289 >=dev-qt/qttest-${QT_MINIMAL}:4
290 >=dev-qt/qtwebkit-${QT_MINIMAL}:4
291"
292
293if [[ ${PN} != kdelibs ]]; then
294 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
295 if [[ ${KDEBASE} = kdevelop ]]; then
296 if [[ ${PN} != kdevplatform ]]; then
297 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
298 # @DESCRIPTION:
299 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
300 # Applies to KDEBASE=kdevelop only.
301 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
302 case ${KDEVPLATFORM_REQUIRED} in
303 always)
304 kdecommondepend+="
305 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}:4
306 "
307 ;;
308 *) ;;
309 esac
310 fi
311 fi
312fi
313
314kdedepend="
315 dev-util/automoc
316 virtual/pkgconfig
317 !aqua? (
318 >=x11-libs/libXtst-1.1.0
319 x11-proto/xf86vidmodeproto
320 )
321"
322
323kderdepend=""
324
325if [[ ${CATEGORY} == kde-apps ]]; then
326 kderdepend+=" !kde-base/${PN}"
327fi
328
329# all packages needs oxygen icons for basic iconset
330if [[ ${PN} != oxygen-icons ]]; then
331 kderdepend+=" kde-apps/oxygen-icons"
332fi
333
334# add a dependency over kde-l10n
335if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} ]]; then
336 for _lingua in ${KDE_LINGUAS}; do
337 # if our package has linguas, pull in kde-l10n with selected lingua enabled,
338 # but only for selected ones.
339 # this can't be done on one line because if user doesn't use any localisation
340 # then he is probably not interested in kde-l10n at all.
341 kderdepend+="
342 linguas_${_lingua}? ( $(add_kdeapps_dep kde4-l10n "linguas_${_lingua}(+)") )
343 "
344 done
345 unset _lingua
346fi
347
348kdehandbookdepend="
349 app-text/docbook-xml-dtd:4.2
350 app-text/docbook-xsl-stylesheets
351"
352kdehandbookrdepend="
353 $(add_kdebase_dep kdelibs 'handbook')
354"
355case ${KDE_HANDBOOK} in
356 always)
357 kdedepend+=" ${kdehandbookdepend}"
358 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
359 ;;
360 optional)
361 IUSE+=" +handbook"
362 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
363 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
364 ;;
365 *) ;;
366esac
367unset kdehandbookdepend kdehandbookrdepend
368
369case ${KDE_SELINUX_MODULE} in
370 none) ;;
108 *) 371 *)
109 CPPUNIT_REQUIRED="never" 372 IUSE+=" selinux"
373 kderdepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
110 ;; 374 ;;
111esac 375esac
112 376
113# @ECLASS-VARIABLE: NEED_KDE 377# We always need the aqua useflag because otherwise we cannot = refer to it inside
114# @DESCRIPTION: 378# add_kdebase_dep. This was always kind of a bug, but came to light with EAPI=5
115# This variable sets the version of KDE4 which will be used by the eclass. 379# (where referring to a use flag not in IUSE masks the ebuild).
116# This variable must be set by the ebuild, for all categories except for "kde-base". 380# The only alternative would be to prohibit using add_kdebase_dep if KDE_REQUIRED=never
117# For kde-base packages, if it is not set by the ebuild, 381IUSE+=" aqua"
118# it's assumed that the required KDE4 version is the latest, non-live, available.
119#
120# @CODE
121# Acceptable values are:
122# - latest - Use latest version in the portage tree
123# Default for kde-base ebuilds. Banned for ebuilds not part of kde or koffice.
124# - svn - Use svn release (live ebuilds)
125# - :SLOT - Use any version in the SLOT specified in the NEED_KDE value.
126# - VERSION_NUMBER - Use the minimum KDE4 version specified in the NEED_KDE value.
127# - VERSION_NUMBER:SLOT - Use the minimum KDE4 version and the SLOT specified in the NEED_KDE value.
128# - none - Let the ebuild handle SLOT, kde dependencies, KDEDIR, ...
129# @CODE
130#
131# Note: There is no default NEED_KDE for ebuilds not in kde-base or part of
132# koffice, so you must set it explicitly in the ebuild, in all other cases.
133if [[ -z ${NEED_KDE} ]]; then
134 if [[ -n ${KDEBASE} ]]; then
135 NEED_KDE="latest"
136 else
137 die "kde4-base.eclass inherited but NEED_KDE not defined - broken ebuild"
138 fi
139fi
140export NEED_KDE
141 382
142case ${NEED_KDE} in 383case ${KDE_REQUIRED} in
143 latest) 384 always)
144 # Should only be used by 'kde-base'-ebuilds 385 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
145 if [[ "${KDEBASE}" == "kde-base" ]]; then 386 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
146 case ${PV} in 387 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
147 3.9*) _kdedir="3.9" ;;
148 4*) _kdedir="4.0" ;;
149 *) die "NEED_KDE=latest not supported for PV=${PV}" ;;
150 esac
151 _operator=">="
152 _pv="-${PV}:kde-4"
153 else
154 _kdedir="4.0"
155 _pv=":kde-4"
156 fi
157 ;; 388 ;;
158 scm|svn|9999*|:kde-svn) 389 optional)
159 _kdedir="svn" 390 IUSE+=" kde"
160 _pv=":kde-svn" 391 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
161 export NEED_KDE="svn" 392 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
393 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
162 ;; 394 ;;
163 *:kde-svn) 395 *) ;;
164 _kdedir="svn"
165 _operator=">="
166 _pv="-${NEED_KDE}"
167 export NEED_KDE="svn"
168 ;;
169 # The ebuild handles dependencies, KDEDIR, SLOT.
170 none)
171 :
172 ;;
173 # NEED_KDE=":${SLOT}"
174 :kde-4)
175 _kdedir="4.0"
176 _pv="${NEED_KDE}"
177 ;;
178 # NEED_KDE="${PV}:${SLOT}"
179 *:kde-4)
180 _kdedir="4.0"
181 _operator=">="
182 _pv="-${NEED_KDE}"
183 ;;
184 3.9*)
185 _kdedir="3.9"
186 _operator=">="
187 _pv="-${NEED_KDE}:kde-4"
188 ;;
189 4*)
190 _kdedir="4.0"
191 _operator=">="
192 _pv="-${NEED_KDE}:kde-4"
193 ;;
194 *) die "NEED_KDE=${NEED_KDE} currently not supported."
195 ;;
196esac 396esac
197 397
198if [[ ${NEED_KDE} != none ]]; then 398unset kdecommondepend kdedepend kderdepend
199 KDEDIR="/usr/kde/${_kdedir}"
200 KDEDIRS="/usr:/usr/local:${KDEDIR}"
201 399
202 if [[ -n ${KDEBASE} ]]; then 400debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
203 if [[ ${NEED_KDE} = svn ]]; then 401debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
204 SLOT="kde-svn" 402debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
205 else
206 SLOT="kde-4"
207 fi
208 fi
209 403
210 # We only need to add the dependencies if ${PN} is not "kdelibs" or "kdepimlibs" 404# Accumulate dependencies set by this eclass
211 if [[ ${PN} != "kdelibs" ]]; then
212 DEPEND="${DEPEND} 405DEPEND+=" ${COMMONDEPEND}"
213 ${_operator}kde-base/kdelibs${_pv}"
214 RDEPEND="${RDEPEND} 406RDEPEND+=" ${COMMONDEPEND}"
215 ${_operator}kde-base/kdelibs${_pv}" 407unset COMMONDEPEND
216 if [[ ${PN} != "kdepimlibs" ]]; then
217 DEPEND="${DEPEND}
218 ${_operator}kde-base/kdepimlibs${_pv}"
219 RDEPEND="${RDEPEND}
220 ${_operator}kde-base/kdepimlibs${_pv}"
221 fi
222 fi
223
224 unset _operator _pv _kdedir
225fi
226 408
227# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 409# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
228# koffice ebuild, the URI should be set in the ebuild itself 410# kdevelop ebuild, the URI should be set in the ebuild itself
229if [[ -n ${KDEBASE} ]]; then 411_calculate_src_uri() {
412 debug-print-function ${FUNCNAME} "$@"
413
414 local _kmname _kmname_pv
415
416 # we calculate URI only for known KDEBASE modules
417 [[ -n ${KDEBASE} ]] || return
418
419 # calculate tarball module name
230 if [[ -n ${KMNAME} ]]; then 420 if [[ -n ${KMNAME} ]]; then
231 _kmname=${KMNAME} 421 _kmname="${KMNAME}"
232 else 422 else
233 _kmname=${PN} 423 _kmname=${PN}
234 fi 424 fi
235 _kmname_pv="${_kmname}-${PV}" 425 _kmname_pv="${_kmname}-${PV}"
236 if [[ ${NEED_KDE} != "svn" ]]; then
237 case ${KDEBASE} in 426 case ${KDEBASE} in
238 kde-base) 427 kde-base)
239 case ${PV} in 428 case ${PV} in
429 4.4.11.1)
430 # KDEPIM 4.4, special case
431 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
432 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" ;;
433 4.4.20*)
434 # KDEPIM 4.4 no-akonadi branch, special case
435 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
436 SRC_URI="http://dev.gentoo.org/~dilfridge/distfiles/${_kmname_pv}.tar.xz" ;;
437 4.?.[6-9]? | 4.??.[6-9]?)
438 # Unstable KDE SC releases
439 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.xz" ;;
440 4.11.14)
441 # Part of 4.14 actually, sigh. Not stable for next release!
442 SRC_URI="mirror://kde/stable/4.14.3/src/${_kmname_pv}.tar.xz" ;;
443 4.11.17)
444 # Part of 14.12.3 actually, sigh. Not stable for next release!
445 SRC_URI="mirror://kde/stable/applications/14.12.3/src/${_kmname_pv}.tar.xz" ;;
446 4.11.18)
447 # Part of 15.04.0 actually, sigh. Not stable for next release!
448 SRC_URI="mirror://kde/stable/applications/15.04.0/src/${_kmname_pv}.tar.xz" ;;
449 4.11.19)
450 # Part of 15.04.1 actually, sigh. Not stable for next release!
451 SRC_URI="mirror://kde/stable/applications/15.04.1/src/${_kmname_pv}.tar.xz" ;;
452 4.11.20)
453 # Part of 15.04.2 actually, sigh. Not stable for next release!
454 SRC_URI="mirror://kde/stable/applications/15.04.2/src/${_kmname_pv}.tar.xz" ;;
455 4.11.21)
456 # Part of 15.04.3 actually, sigh. Not stable for next release!
457 SRC_URI="mirror://kde/stable/applications/15.04.3/src/${_kmname_pv}.tar.xz" ;;
458 4.14.3)
459 # Last SC release
240 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2";; 460 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.xz" ;;
461 4.14.6)
462 # Part of 14.12.3 actually, sigh. Not stable for next release!
463 SRC_URI="mirror://kde/stable/applications/14.12.3/src/${_kmname_pv}.tar.xz" ;;
464 4.14.7)
465 # Part of 15.04.0 actually, sigh. Not stable for next release!
466 SRC_URI="mirror://kde/stable/applications/15.04.0/src/${_kmname_pv}.tar.xz" ;;
467 4.14.8)
468 # Part of 15.04.1 actually, sigh. Not stable for next release!
469 SRC_URI="mirror://kde/stable/applications/15.04.1/src/${_kmname_pv}.tar.xz" ;;
470 4.14.9)
471 # Part of 15.04.2 actually, sigh. Not stable for next release!
472 SRC_URI="mirror://kde/stable/applications/15.04.2/src/${_kmname_pv}.tar.xz" ;;
473 4.14.10)
474 # Part of 15.04.3 actually, sigh. Not stable for next release!
475 SRC_URI="mirror://kde/stable/applications/15.04.3/src/${_kmname_pv}.tar.xz" ;;
476 ??.?.[6-9]? | ??.??.[4-9]?)
477 # Unstable KDE Applications releases
478 SRC_URI="mirror://kde/unstable/applications/${PV}/src/${_kmname}-${PV}.tar.xz" ;;
479 *)
480 # Stable KDE Applications releases
481 SRC_URI="mirror://kde/stable/applications/${PV}/src/${_kmname}-${PV}.tar.xz"
482 ;;
241 esac 483 esac
242 ;; 484 ;;
243 koffice) 485 kdevelop|kdevelop-php*|kdevplatform)
244 SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2" 486 case ${KDEVELOP_VERSION} in
487 4.[123].[6-9]*) SRC_URI="mirror://kde/unstable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.xz" ;;
488 *) SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.xz" ;;
489 esac
245 ;; 490 ;;
491 esac
492}
493
494_calculate_live_repo() {
495 debug-print-function ${FUNCNAME} "$@"
496
497 SRC_URI=""
498 case ${KDE_SCM} in
499 svn)
500 # Determine branch URL based on live type
501 local branch_prefix
502 case ${PV} in
503 9999*)
504 # trunk
505 branch_prefix="trunk/KDE"
506 ;;
507 *)
508 # branch
509 branch_prefix="branches/KDE/$(get_kde_version)"
510 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
511 # @DESCRIPTION
512 # Suffix appended to ESVN_PROJECT depending on fetched branch.
513 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
514 ESVN_PROJECT_SUFFIX="-${PV}"
515 ;;
516 esac
517 # @ECLASS-VARIABLE: ESVN_MIRROR
518 # @DESCRIPTION:
519 # This variable allows easy overriding of default kde mirror service
520 # (anonsvn) with anything else you might want to use.
521 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
522 # Split ebuild, or extragear stuff
523 if [[ -n ${KMNAME} ]]; then
524 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
525 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
526 KMMODULE="${PN}"
527 fi
528 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
529 case ${KMNAME} in
530 kdebase-*)
531 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
532 ;;
533 kdelibs-*)
534 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
535 ;;
536 kdereview*)
537 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
538 ;;
539 kdesupport)
540 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
541 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
542 ;;
543 kde*)
544 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
545 ;;
546 extragear*|playground*)
547 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
548 # build packages from same svn location.
549 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
550 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
551 ;;
552 *)
553 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
554 ;;
555 esac
556 else
557 # kdelibs, kdepimlibs
558 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
559 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
560 fi
561 # @ECLASS-VARIABLE: ESVN_UP_FREQ
562 # @DESCRIPTION:
563 # This variable is used for specifying the timeout between svn synces
564 # for kde-base modules. Does not affect misc apps.
565 # Default value is 1 hour.
566 [[ ${KDEBASE} = kde-base ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
567 ;;
568 git)
569 local _kmname
570 # @ECLASS-VARIABLE: EGIT_MIRROR
571 # @DESCRIPTION:
572 # This variable allows easy overriding of default kde mirror service
573 # (anongit) with anything else you might want to use.
574 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
575
576 # @ECLASS-VARIABLE: EGIT_REPONAME
577 # @DESCRIPTION:
578 # This variable allows overriding of default repository
579 # name. Specify only if this differ from PN and KMNAME.
580 if [[ -n ${EGIT_REPONAME} ]]; then
581 # the repository and kmname different
582 _kmname=${EGIT_REPONAME}
583 elif [[ -n ${KMNAME} ]]; then
584 _kmname=${KMNAME}
585 else
586 _kmname=${PN}
587 fi
588
589 # default branching
590 [[ ${PV} != 4.9999* && ${PV} != 9999 && ${KDEBASE} == kde-base ]] && \
591 EGIT_BRANCH="KDE/$(get_kde_version)"
592
593 # Applications branching
594 [[ ${PV} == ??.??.49.9999 && ${KDEBASE} == kde-base ]] && \
595 EGIT_BRANCH="Applications/$(get_kde_version)"
596
597 # default repo uri
598 EGIT_REPO_URI+=( "${EGIT_MIRROR}/${_kmname}" )
599
600 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
601 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
602 ;;
603 esac
604}
605
606case ${KDE_BUILD_TYPE} in
607 live) _calculate_live_repo ;;
608 *) _calculate_src_uri ;;
609esac
610
611debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
612
613# @ECLASS-VARIABLE: PREFIX
614# @DESCRIPTION:
615# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
616# kde-base packages go into KDE4 installation directory (/usr).
617# No matter the PREFIX, package will be built against KDE installed in /usr.
618
619# @FUNCTION: kde4-base_pkg_setup
620# @DESCRIPTION:
621# Do some basic settings
622kde4-base_pkg_setup() {
623 debug-print-function ${FUNCNAME} "$@"
624
625 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
626 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
627 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
628 fi
629
630 # Don't set KDEHOME during compilation, it will cause access violations
631 unset KDEHOME
632
633 # Check if gcc compiler is fresh enough.
634 # In theory should be in pkg_pretend but we check it only for kdelibs there
635 # and for others we do just quick scan in pkg_setup because pkg_pretend
636 # executions consume quite some time (ie. when merging 300 packages at once will cause 300 checks)
637 if [[ ${MERGE_TYPE} != binary ]]; then
638 [[ $(gcc-major-version) -lt 4 ]] || \
639 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 6 ]] ) \
640 && die "Sorry, but gcc-4.6 and earlier wont work for some KDE packages."
641 fi
642
643 KDEDIR=/usr
644 : ${PREFIX:=/usr}
645 EKDEDIR=${EPREFIX}/usr
646
647 # Point to correct QT plugins path
648 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
649
650 # Fix XDG collision with sandbox
651 export XDG_CONFIG_HOME="${T}"
652}
653
654# @FUNCTION: kde4-base_src_unpack
655# @DESCRIPTION:
656# This function unpacks the source tarballs for KDE4 applications.
657kde4-base_src_unpack() {
658 debug-print-function ${FUNCNAME} "$@"
659
660 if [[ ${KDE_BUILD_TYPE} = live ]]; then
661 case ${KDE_SCM} in
662 svn)
663 subversion_src_unpack
664 ;;
665 git)
666 git-r3_src_unpack
667 ;;
246 esac 668 esac
247 fi
248 unset _kmname _kmname_pv
249fi
250
251debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
252debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND ${DEPEND} - before blockers"
253
254# Monolithic ebuilds should add blockers for split ebuilds in the same slot.
255# If KMNAME is not set then this is not a split package
256if [[ -n ${KDEBASE} && -z ${KMNAME} ]]; then
257 for _x in $(get-child-packages ${CATEGORY}/${PN}); do
258 DEPEND="${DEPEND} !${_x}:${SLOT}"
259 RDEPEND="${RDEPEND} !${_x}:${SLOT}"
260 done
261 unset _x
262fi
263
264debug-print "${BASH_SOURCE} ${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND ${DEPEND} - after blockers"
265
266# @ECLASS-VARIABLE: PREFIX
267# @DESCRIPTION:
268# Set the installation PREFIX. All kde-base ebuilds go into the KDE4 installation directory.
269# Applications installed by the other ebuilds go into /usr/ by default, this value
270# can be superseded by defining PREFIX before inheriting kde4-base.
271if [[ -n ${KDEBASE} ]]; then
272 PREFIX=${KDEDIR}
273else
274 # if PREFIX is not defined we set it to the default value of /usr
275 PREFIX="${PREFIX:-/usr}"
276fi
277
278debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SLOT ${SLOT} - KDEDIR ${KDEDIR} - KDEDIRS ${KDEDIRS}- PREFIX ${PREFIX} - NEED_KDE ${NEED_KDE}"
279
280# @FUNCTION: kde4-base_pkg_setup
281# @DESCRIPTION:
282# Adds flags needed by all of KDE 4 to $QT4_BUILT_WITH_USE_CHECK. Uses
283# kde4-functions_check_use from kde4-functions.eclass to print appropriate
284# errors and die if any required flags listed in $QT4_BUILT_WITH_USE_CHECK or
285# $KDE4_BUILT_WITH_USE_CHECK are missing.
286kde4-base_pkg_setup() {
287 debug-print-function $FUNCNAME "$@"
288
289 case "${EAPI}" in
290 kdebuild-1)
291 [[ -n ${QT4_BUILT_WITH_USE_CHECK} || -n ${KDE4_BUILT_WITH_USE_CHECK[@]} ]] && \
292 die "built_with_use illegal in this EAPI!"
293 ;;
294 *)
295 # Make KDE4_BUILT_WITH_USE_CHECK an array if it isn't already
296 local line kde4_built_with_use_check=()
297 if [[ -n ${KDE4_BUILT_WITH_USE_CHECK[@]} && $(declare -p KDE4_BUILT_WITH_USE_CHECK) != 'declare -a '* ]]; then
298 while read line; do
299 [[ -z ${line} ]] && continue
300 kde4_built_with_use_check+=("${line}")
301 done <<< "${KDE4_BUILT_WITH_USE_CHECK}"
302 KDE4_BUILT_WITH_USE_CHECK="${kde4_built_with_use_check[@]}"
303 fi
304
305 # KDE4 applications require qt4 compiled with USE="accessibility dbus gif jpeg png qt3support ssl zlib".
306 if has_version '<x11-libs/qt-4.4_alpha:4'; then
307 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} accessibility dbus gif jpeg png qt3support ssl zlib"
308 else 669 else
309 KDE4_BUILT_WITH_USE_CHECK=("${KDE4_BUILT_WITH_USE_CHECK[@]}" 670 unpack ${A}
310 "x11-libs/qt-core qt3support ssl"
311 "x11-libs/qt-gui accessibility dbus"
312 "x11-libs/qt-qt3support accessibility")
313 fi 671 fi
314
315 if has opengl ${IUSE//+} && use opengl || [[ ${OPENGL_REQUIRED} == always ]]; then
316 if has_version '<x11-libs/qt-4.4.0_alpha:4'; then
317 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} opengl"
318 fi
319 fi
320 kde4-functions_check_use
321 ;;
322 esac
323} 672}
324 673
325# @FUNCTION: kde4-base_apply_patches
326# @DESCRIPTION:
327# This function applies patches.
328#
329# If the directory ${WORKDIR}/patches/ exists, we apply all patches in that
330# directory, provided they follow this format:
331# @CODE
332# - Monolithic ebuilds, (from kde-base)
333# - $CATEGORY=kde-base:
334# Apply ${CHILD_EBUILD_NAME}-${SLOT}-*{diff,patch}
335# - $CATEGORY=!kde-base:
336# Apply ${CHILD_EBUILD_NAME}-${PV}-*{diff,patch}
337# - Split ebuilds:
338# - $CATEGORY=kde-base:
339# Apply ${PN}-${SLOT}-*{diff,patch}
340# - $CATEGORY!=kde-base:
341# Apply ${PN}-${PV}-*{diff,patch}
342# @CODE
343#
344# If ${PATCHES} is non-zero all patches in it get applied. If there is more
345# than one patch please make ${PATCHES} an array for proper quoting.
346kde4-base_apply_patches() {
347 local _patchdir _packages _p _f
348 _patchdir="${WORKDIR}/patches/"
349 if [[ -d "${_patchdir}" ]]; then
350 if is-parent-package ${CATEGORY}/${PN} ; then
351 _packages="$(get-child-packages ${CATEGORY}/${PN})"
352 _packages="${_packages//${CATEGORY}\//} ${PN}"
353 else
354 _packages="${PN}"
355 fi
356 if [[ $(declare -p PATCHES) != 'declare -a '* ]]; then
357 PATCHES=(${PATCHES})
358 fi
359 for _p in ${_packages}; do
360 for _f in "${_patchdir}"/${_p}-${PV}-*{diff,patch}; do
361 [[ -e ${_f} ]] && PATCHES+=("${_f}")
362 done
363 if [[ -n "${KDEBASE}" ]]; then
364 for _f in "${_patchdir}"/${_p}-${SLOT}-*{diff,patch}; do
365 [[ -e ${_f} ]] && PATCHES+=("${_f}")
366 done
367 fi
368 done
369 fi
370 [[ -n ${PATCHES[@]} ]] && base_src_unpack autopatch
371}
372
373# @FUNCTION: kde4-base_src_unpack 674# @FUNCTION: kde4-base_src_prepare
374# @DESCRIPTION: 675# @DESCRIPTION:
375# This function unpacks the source tarballs for KDE4 applications. 676# General pre-configure and pre-compile function for KDE4 applications.
376#
377# If no argument is passed to this function, then standard src_unpack is
378# executed. Otherwise options are passed to base_src_unpack.
379#
380# In addition it calls kde4-base_apply_patches when no arguments are passed to
381# this function.
382#
383# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and 677# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and
678# enable_selected_linguas() and enable_selected_doc_linguas()
384# enable_selected_linguas() in kde4-functions.eclass(5) for further details. 679# in kde4-functions.eclass(5) for further details.
385kde4-base_src_unpack() { 680kde4-base_src_prepare() {
386 debug-print-function $FUNCNAME "$@" 681 debug-print-function ${FUNCNAME} "$@"
387 682
388 [[ -z "${KDE_S}" ]] && KDE_S="${S}" 683 # enable handbook and linguas only when not using live ebuild
389
390 if [[ -z $* ]]; then
391 # Unpack first and deal with KDE patches after examing possible patch sets.
392 # To be picked up, patches need to conform to the guidelines stated before.
393 # Monolithic ebuilds will use the split ebuild patches.
394 [[ -d "${KDE_S}" ]] || unpack ${A}
395 kde4-base_apply_patches
396 else
397 # Call base_src_unpack, which unpacks and patches
398 # step by step transparently as defined in the ebuild.
399 base_src_unpack $*
400 fi
401
402 # Updated cmake dir
403 if [[ -d "${WORKDIR}/cmake" ]] && [[ -d "${KDE_S}/cmake" ]]; then
404 ebegin "Updating cmake/ directory..."
405 rm -rf "${KDE_S}/cmake" || die "Unable to remove old cmake/ directory"
406 ln -s "${WORKDIR}/cmake" "${KDE_S}/cmake" || die "Unable to symlink the new cmake/ directory"
407 eend 0
408 fi
409 684
410 # Only enable selected languages, used for KDE extragear apps. 685 # Only enable selected languages, used for KDE extragear apps.
411 if [[ -n ${KDE_LINGUAS} ]]; then 686 if [[ -n ${KDE_LINGUAS} ]]; then
412 enable_selected_linguas 687 enable_selected_linguas
413 fi 688 fi
689
690 # Enable/disable handbooks for kde4-base packages
691 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
692 # kdelibs inherits kde4-base but handle installing the handbook itself
693 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
694 if [[ ${KDEBASE} == kde-base ]]; then
695 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
696 # documentation in kde4-functions
697 : ${KDE_DOC_DIRS:=doc}
698 local dir
699 for dir in ${KDE_DOC_DIRS}; do
700 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
701 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
702 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
703 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
704 -i CMakeLists.txt || die "failed to comment out handbook"
705 done
706 fi
707 else
708 enable_selected_doc_linguas
709 fi
710 fi
711
712 # SCM bootstrap
713 if [[ ${KDE_BUILD_TYPE} = live ]]; then
714 case ${KDE_SCM} in
715 svn) subversion_src_prepare ;;
716 esac
717 fi
718
719 # Apply patches, cmake-utils does the job already
720 cmake-utils_src_prepare
721
722 # Save library dependencies
723 if [[ -n ${KMSAVELIBS} ]] ; then
724 save_library_dependencies
725 fi
726
727 # Inject library dependencies
728 if [[ -n ${KMLOADLIBS} ]] ; then
729 load_library_dependencies
730 fi
731
732 # Hack for manuals relying on outdated DTD, only outside kde-base/...
733 if [[ -z ${KDEBASE} ]]; then
734 find "${S}" -name "*.docbook" \
735 -exec sed -i -r \
736 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
737 || die 'failed to fix DocBook variant version'
738 fi
739}
740
741# @FUNCTION: kde4-base_src_configure
742# @DESCRIPTION:
743# Function for configuring the build of KDE4 applications.
744kde4-base_src_configure() {
745 debug-print-function ${FUNCNAME} "$@"
746
747 # Build tests in src_test only, where we override this value
748 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
749
750 if use_if_iuse debug; then
751 # Set "real" debug mode
752 CMAKE_KDE_BUILD_TYPE="Debugfull"
753 else
754 # Handle common release builds
755 append-cppflags -DQT_NO_DEBUG
756 fi
757
758 # Set distribution name
759 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
760
761 # Here we set the install prefix
762 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
763
764 # Use colors
765 QTEST_COLORED=1
766
767 # Shadow existing installations
768 unset KDEDIRS
769
770 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
771 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
772 #kde-config -path data unavailable when cross-compiling
773 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
774
775 # sysconf needs to be /etc, not /usr/etc
776 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
777
778 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
779 if [[ ${mycmakeargs} ]]; then
780 eqawarn "mycmakeargs should always be declared as an array, not a string"
781 fi
782 mycmakeargs=(${mycmakeargs})
783 fi
784
785 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
786
787 cmake-utils_src_configure
414} 788}
415 789
416# @FUNCTION: kde4-base_src_compile 790# @FUNCTION: kde4-base_src_compile
417# @DESCRIPTION: 791# @DESCRIPTION:
418# General function for compiling KDE4 applications. 792# General function for compiling KDE4 applications.
419kde4-base_src_compile() { 793kde4-base_src_compile() {
420 debug-print-function ${FUNCNAME} "$@" 794 debug-print-function ${FUNCNAME} "$@"
421 795
422 kde4-base_src_configure
423 kde4-base_src_make
424}
425
426# @FUNCTION: kde4-base_src_configure
427# @DESCRIPTION:
428# Function for configuring the build of KDE4 applications.
429kde4-base_src_configure() {
430 debug-print-function ${FUNCNAME} "$@"
431
432 # Final flag handling
433 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
434 echo "Activating enable-final flag"
435 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_FINAL=ON"
436 fi
437
438 # Enable generation of HTML handbook
439 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then
440 echo "Enabling building of HTML handbook"
441 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_HTMLHANDBOOK=ON"
442 fi
443
444 # Build tests in src_test only, where we override this value
445 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=OFF"
446
447 # Set distribution name
448 [[ ${PN} == "kdelibs" ]] && mycmakeargs="${mycmakeargs} -DKDE_DISTRIBUTION_TEXT=Gentoo"
449
450 # runpath linking
451 mycmakeargs="${mycmakeargs} -DKDE4_USE_ALWAYS_FULL_RPATH=ON"
452
453 # Here we set the install prefix
454 mycmakeargs="${mycmakeargs} -DCMAKE_INSTALL_PREFIX=${PREFIX}"
455
456 # Set environment
457 QTEST_COLORED=1
458 QT_PLUGIN_PATH=${KDEDIR}/$(get_libdir)/kde4/plugins/
459
460 cmake-utils_src_configureout
461}
462
463# @FUNCTION: kde4-base_src_make
464# @DESCRIPTION:
465# Function for building KDE4 applications.
466# Options are passed to cmake-utils_src_make.
467kde4-base_src_make() {
468 debug-print-function ${FUNCNAME} "$@"
469
470 cmake-utils_src_make "$@" 796 cmake-utils_src_compile "$@"
471} 797}
472 798
473# @FUNCTION: kde4-base_src_test 799# @FUNCTION: kde4-base_src_test
474# @DESCRIPTION: 800# @DESCRIPTION:
475# Function for testing KDE4 applications. 801# Function for testing KDE4 applications.
476kde4-base_src_test() { 802kde4-base_src_test() {
477 debug-print-function ${FUNCNAME} "$@" 803 debug-print-function ${FUNCNAME} "$@"
478 804
805 local kded4_pid
806
807 _test_runner() {
808 if [[ -n "${VIRTUALDBUS_TEST}" ]]; then
809 export $(dbus-launch)
810 kded4 2>&1 > /dev/null &
811 kded4_pid=$!
812 fi
813
814 cmake-utils_src_test
815 }
816
817 # When run as normal user during ebuild development with the ebuild command, the
818 # kde tests tend to access the session DBUS. This however is not possible in a real
819 # emerge or on the tinderbox.
820 # > make sure it does not happen, so bad tests can be recognized and disabled
821 unset DBUS_SESSION_BUS_ADDRESS DBUS_SESSION_BUS_PID
822
479 # Override this value, set in kde4-base_src_configure() 823 # Override this value, set in kde4-base_src_configure()
480 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=ON" 824 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
481 cmake-utils_src_compile 825 cmake-utils_src_configure
826 kde4-base_src_compile
482 827
483 cmake-utils_src_test 828 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
829 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
830 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
831 # surprise- we are already INSIDE virtualmake!!!
832 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
833 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
834 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
835 debug-print " kde4-base.eclass docs for details... Applying workaround."
836 _test_runner
837 else
838 VIRTUALX_COMMAND="_test_runner" virtualmake
839 fi
840 else
841 _test_runner
842 fi
843
844 if [ -n "${kded4_pid}" ] ; then
845 kill ${kded4_pid}
846 fi
847
848 if [ -n "${DBUS_SESSION_BUS_PID}" ] ; then
849 kill ${DBUS_SESSION_BUS_PID}
850 fi
484} 851}
485 852
486# @FUNCTION: kde4-base_src_install 853# @FUNCTION: kde4-base_src_install
487# @DESCRIPTION: 854# @DESCRIPTION:
488# Function for installing KDE4 applications. 855# Function for installing KDE4 applications.
489kde4-base_src_install() { 856kde4-base_src_install() {
490 debug-print-function ${FUNCNAME} "$@" 857 debug-print-function ${FUNCNAME} "$@"
491 858
492 kde4-base_src_make_doc 859 if [[ -n ${KMSAVELIBS} ]] ; then
860 install_library_dependencies
861 fi
862
863 # Install common documentation of KDE4 applications
864 local doc
865 if ! has kde4-meta ${INHERITED}; then
866 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
867 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
868 done
869 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
870 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
871 done
872 fi
873
493 cmake-utils_src_install 874 cmake-utils_src_install
494}
495 875
496# @FUNCTION: kde4-base_src_make_doc 876 # We don't want ${PREFIX}/share/doc/HTML to be compressed,
497# @DESCRIPTION: 877 # because then khelpcenter can't find the docs
498# Function for installing the documentation of KDE4 applications. 878 [[ -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
499kde4-base_src_make_doc() { 879 docompress -x ${PREFIX}/share/doc/HTML
500 debug-print-function ${FUNCNAME} "$@" 880}
501 881
502 local doc 882# @FUNCTION: kde4-base_pkg_preinst
503 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 883# @DESCRIPTION:
504 [[ -s $doc ]] && dodoc ${doc} 884# Function storing icon caches
505 done 885kde4-base_pkg_preinst() {
886 debug-print-function ${FUNCNAME} "$@"
506 887
507 if [[ -z ${KMNAME} ]]; then 888 gnome2_icon_savelist
508 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do 889 if [[ ${KDE_BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
509 if [[ -s $doc ]]; then 890 subversion_pkg_preinst
510 local doc_complete=${doc}
511 doc="${doc#*/}"
512 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
513 fi
514 done
515 fi
516
517 if [[ -n ${KDEBASE} && -d "${D}"/usr/share/doc/${PF} ]]; then
518 # work around bug #97196
519 dodir /usr/share/doc/kde && \
520 mv "${D}"/usr/share/doc/${PF} "${D}"/usr/share/doc/kde/ || \
521 die "Failed to move docs to kde/ failed."
522 fi 891 fi
523} 892}
524 893
525# @FUNCTION: kde4-base_pkg_postinst 894# @FUNCTION: kde4-base_pkg_postinst
526# @DESCRIPTION: 895# @DESCRIPTION:
527# Function to rebuild the KDE System Configuration Cache after an application has been installed. 896# Function to rebuild the KDE System Configuration Cache after an application has been installed.
528kde4-base_pkg_postinst() { 897kde4-base_pkg_postinst() {
898 debug-print-function ${FUNCNAME} "$@"
899
900 gnome2_icon_cache_update
901 fdo-mime_desktop_database_update
902 fdo-mime_mime_database_update
529 buildsycoca 903 buildsycoca
904
905 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
906 if [[ ${KDE_BUILD_TYPE} = live ]]; then
907 echo
908 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
909 einfo "Use it at your own risk."
910 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
911 echo
912 fi
913 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
914 if [[ ${KDEBASE} != kde-base ]] && \
915 ! has_version 'kde-apps/kdebase-runtime-meta' && \
916 ! has_version 'kde-base/kdebase-startkde'; then
917 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
918 echo
919 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
920 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
921 ewarn "With this setting you are unsupported by KDE team."
922 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
923 fi
924 fi
925 fi
530} 926}
531 927
532# @FUNCTION: kde4-base_pkg_postrm 928# @FUNCTION: kde4-base_pkg_postrm
533# @DESCRIPTION: 929# @DESCRIPTION:
534# Function to rebuild the KDE System Configuration Cache after an application has been removed. 930# Function to rebuild the KDE System Configuration Cache after an application has been removed.
535kde4-base_pkg_postrm() { 931kde4-base_pkg_postrm() {
932 debug-print-function ${FUNCNAME} "$@"
933
934 gnome2_icon_cache_update
935 fdo-mime_desktop_database_update
936 fdo-mime_mime_database_update
536 buildsycoca 937 buildsycoca
537} 938}
939
940fi

Legend:
Removed from v.1.11  
changed lines
  Added in v.1.157

  ViewVC Help
Powered by ViewVC 1.1.20